variables:
    GIT_SUBMODULE_STRATEGY: recursive
    SAST_EXCLUDED_PATHS: spec, test, tests, tmp, assets/js/select2.*, assets/js/i18n/*.js

include:
    - template: Dependency-Scanning.gitlab-ci.yml
    - template: Security/SAST.gitlab-ci.yml
    - template: Security/License-Scanning.gitlab-ci.yml
    - template: Code-Quality.gitlab-ci.yml

stages:
    - lint
    - test
    - package

jshint:
    stage: lint
    image: node:latest
    before_script:
        - npm install
    script:
        - "./node_modules/grunt/bin/grunt lint_jshint"

stylelint:
    stage: lint
    image: node:latest
    before_script:
        - npm install
    script:
        - ./node_modules/stylelint/bin/stylelint.js "**/*.css"

markdownlint:
    stage: lint
    image: node:latest
    before_script:
        - npm install
    script:
        - "./node_modules/grunt/bin/grunt lint_markdownlint"

i18n:
    stage: test
    image: node:latest
    before_script:
        - npm install
    script:
        - "./node_modules/grunt/bin/grunt standards_i18n"

phpsyntax:
    stage: test
    image: edbizarro/gitlab-ci-pipeline-php:7.4
    before_script:
        - bash bin/docker_install.sh > /dev/null
        - npm install
    script:
        - composer install --prefer-dist --no-ansi --no-interaction --no-progress
        - "./node_modules/grunt/bin/grunt standards_phpsyntax"

phpcs:
    stage: test
    image: edbizarro/gitlab-ci-pipeline-php:7.4
    before_script:
        - bash bin/docker_install.sh > /dev/null
        - npm install
    script:
        - composer install --prefer-dist --no-ansi --no-interaction --no-progress
        - "./node_modules/grunt/bin/grunt standards_phpcs"

phpunit:
    stage: test
    variables:
        MYSQL_DATABASE: wordpress_tests
        MYSQL_ROOT_PASSWORD: mysql
        DB_HOST: mysql
        XDEBUG_MODE: coverage
    image: edbizarro/gitlab-ci-pipeline-php:7.4
    services:
        - mariadb
    before_script:
        - bash bin/docker_install.sh > /dev/null
        - bash bin/install-wp-tests.sh wordpress_tests root mysql mariadb trunk true
        - npm install
    script:
        - composer install --prefer-dist --no-ansi --no-interaction --no-progress
        - "./vendor/phpunit/phpunit/phpunit --color=always --debug --configuration phpunit.xml"

code_quality:
    variables:
      REPORT_FORMAT: html
    artifacts:
        paths: [gl-code-quality-report.html]
